/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.Vector;
import javax.swing.JPanel;

/**
 * Clase que ejecuta las acciones.
 * @author Miguel Angel Pescador Santirso
 */
public class EjecutarAcciones extends Thread{

    Vector elementos;
    Sistema sis;
    boolean hablando=false;
    boolean moviendo=false;
    String personaje;
    Cuarto habi;
    /**
     * Constructor de la Clase  ejecuar acciones.
     * @param sistema Valores del sistema.
     * @param acciones Acciones a ejecutar
     * @param room habitaciones del juego.
     * @param g cursor de graficos.
     * @param propietario clase desde la que es llamado.
     */
    @SuppressWarnings("static-access")
    public EjecutarAcciones(Sistema sistema, Vector acciones,Vector room, Graphics g, final JPanel propietario){
        for(int f=0;f<room.size();f++){
            if(((Cuarto)room.get(f)).nombre.equals(sistema.habitacionInicial)){
                habi=(Cuarto)room.get(f);
            }
        }
        elementos=habi.elementos;
        sis=sistema;
        Vector accion;
        
        for(int i=0;i<acciones.size();i++){
            
            accion=(Vector)acciones.get(i);
            //System.out.println(accion.get(0).toString());
            int clase=Integer.parseInt(accion.get(0).toString());
            switch(clase){

                    case 0://Seleccionar elemento y calcular posicion de texto
                       System.out.println("Instruccion DI");
                        personaje=accion.get(1).toString().trim();
                        int tinta=-1;
                        int[] pos=new int[3];
                        int alto=0;
                        for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                pos=ele.getPosicion();
                                alto=ele.getImagen().getHeight(null);
                                if(ele.tinta!=-1){
                                    tinta=ele.tinta;
                                }
                             }
                        }
                        final int posx=pos[0];
                        int escalaAlto=0;
                        if(pos[2]!=0){
                            double esc=((double)pos[2])/100;
                            escalaAlto = (int)( esc*alto );
                        }else{escalaAlto=pos[1];}
                        final int posy=escalaAlto;
                        final int tin=tinta;
                        final String texto=accion.get(2).toString();
                        
                        //Dibujar Texto, esperar 2 segundos y borrarlo
                        Runnable miRunnableDi = new Runnable()
                        {
                        public void run()
                        {

                        while (hablando==true){
                            try {
                                        sleep( 250 );
                                    } catch( InterruptedException e ) {
                                }
                        }
                        hablando=true;
                        Graphics h=propietario.getGraphics();
                        h.setFont(sis.fuente);
                        h.setColor(Color.GREEN);
                        if(tin!=-1){
                            switch(tin){
                                case 0:h.setColor(Color.BLACK);
                                break;
                                case 1:h.setColor(Color.BLUE);
                                break;
                                case 2:h.setColor(Color.RED);
                                break;
                                case 3:h.setColor(Color.PINK);
                                break;
                                case 4:h.setColor(Color.GREEN);
                                break;
                                case 5:h.setColor(Color.CYAN);
                                break;
                                case 6:h.setColor(Color.YELLOW);
                                break;
                                case 7:h.setColor(Color.WHITE);
                                break;
                                case 8:h.setColor(Color.GRAY);
                                break;
                                case 9:h.setColor(Color.ORANGE);
                                break;
                            }
                        }
                        h.drawString(texto, posx-10, posy-10);
                        h.dispose();
                        System.out.println(personaje+" : "+texto);

                        //propietario.update(propietario.getGraphics());
                       try {
                                        sleep( 2500 );
                                    } catch( InterruptedException e ) {
                                }
                        hablando=false;
                        propietario.update(propietario.getGraphics());
                         }
                         };
                        Thread hilo = new Thread (miRunnableDi);
                        hilo.start();

                        break;
                    case 1:System.out.println("Instruccion Mover");
                    final int posFinX=Integer.parseInt(accion.get(2).toString());
                    final int posFinY=Integer.parseInt(accion.get(3).toString());
                    final int posFinZ=Integer.parseInt(accion.get(4).toString());

                    personaje=accion.get(1).toString().trim();
                    
                       Runnable miRunnableAndar = new Runnable()
                        {
                        public void run()
                        {
                         while (moviendo==true){
                            try {
                                        sleep( 1000/sis.fps );
                                    } catch( InterruptedException e ) {
                                }
                        }
                         moviendo=true;
                       for(int j=0;j<elementos.size();j++){
                           BufferedImage bufferedImage;
                           Color mascolor;
                           Elemento ele=(Elemento)elementos.get(j);
                           mascolor=Color.WHITE;
                           bufferedImage = new BufferedImage( sis.PANTALLAHORIZONTAL,sis.PANTALLAVERTICAL,BufferedImage.TYPE_INT_RGB );

                           if(habi.getMascara()!=null){
                                    Image mascara=habi.getMascara().getImage();
                                    int alto=mascara.getHeight(null);
                                    int ancho=mascara.getWidth(null);
                                    if(alto>sis.PANTALLAVERTICAL){
                                        alto=alto-sis.PANTALLAVERTICAL;
                                    }else{alto=0;}
                                    if(ancho>sis.PANTALLAHORIZONTAL){
                                        ancho=0;//ancho-sis.PANTALLAHORIZONTAL;
                                    }else{ancho=0;}
                                    Graphics masgra = bufferedImage.createGraphics();
                                    masgra.drawImage(mascara,-ancho,-alto,null);
                                    masgra.dispose();
                                    mascolor=new Color(bufferedImage.getRGB(posFinX,posFinY));
                                }
                                if(mascolor.equals(Color.BLACK)){
                                    if(personaje.equals(ele.nombre.trim())){
                                            int[] posi=new int[3];
                                            posi=ele.getPosicion();
                                            Graphics h=propietario.getGraphics();
                                            h.setFont(sis.fuente);
                                            h.setColor(Color.GREEN);
                                            h.drawString("No puedo ir ahi", posi[0]-10, posi[1]-10);
                                            h.dispose();
                                            try {
                                        sleep( 2500 );
                                    } catch( InterruptedException e ) {
                                }
                                propietario.update(propietario.getGraphics());
                                    }
                                }
                                if(mascolor.equals(Color.WHITE)){


                            
                            if(personaje.equals(ele.nombre.trim())){
                                int[] posi=new int[3];
                                posi=ele.getPosicion();
                                Image elementoImagen=ele.getImagen();
                                int posH=elementoImagen.getHeight(propietario);
                                int posW=elementoImagen.getWidth(propietario);
                                int posHsinescala=posH;
                                int OFFSET=1;
                                
                                                            
                                while(posi[0]!=posFinX || posi[1]!=posFinY){
                                    //System.out.println(posi[0]+"+"+posi[1]+" Final "+posFinX+":"+posFinY);
                                    if(posi[2]!=0){
                                        //System.out.println("escala");
                                        double esc=((double)posi[2])/100;
                                        posH=(int)esc*posH;
                                        posW=(int)esc*posW;
                                    }

                                   if(posFinX>posi[0]){
                                       /*if(habi.getMascara()!=null){
                                        mascolor=new Color(bufferedImage.getRGB(posi[0]++OFFSET, posi[1]));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[0]=posi[0]+OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=5;
                                        propietario.update(propietario.getGraphics());
                                       //}
                                    }else if(posFinX<posi[0]){
                                      /*  if(habi.getMascara()!=null){
                                        mascolor=new Color(bufferedImage.getRGB(posi[0]-OFFSET, posi[1]));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[0]=posi[0]-OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=7;
                                        propietario.update(propietario.getGraphics());
                                      // }
                                    }else if(posFinY>posi[1]){
                                      /*  if(habi.getMascara()!=null){
                                         mascolor=new Color(bufferedImage.getRGB(posi[0], posi[1]+OFFSET));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[1]=posi[1]+OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=4;
                                        propietario.update(propietario.getGraphics());
                                      // }
                                    }else if(posFinY<posi[1]){
                                        /*if(habi.getMascara()!=null){
                                         mascolor=new Color(bufferedImage.getRGB(posi[0], posi[1]-OFFSET));
                                       }
                                       if(mascolor.equals(Color.WHITE)||habi.getMascara()==null){*/
                                        posi[1]=posi[1]-OFFSET;
                                        ele.setPosicion(posi[0],posi[1],posi[2]);
                                        try { sleep( 1000/sis.fps ); } catch( InterruptedException e ) {}
                                        ele.animacion.possprite++;
                                        ele.animacion.imagenamostrar=6;
                                        propietario.update(propietario.getGraphics());
                                    }//}
                                    try {
                                        sleep( 1000/sis.fps );
                                    } catch( InterruptedException e ) {
                                }
                                   
                            }
                            ele.animacion.imagenamostrar=0;
                            propietario.update(propietario.getGraphics());
                            moviendo=false;
                            }}
                            }
                       }

                         
                         };
                        Thread hilo2 = new Thread (miRunnableAndar);
                        hilo2.start();
                        
                        break;
                    case 2:System.out.println("Entra en Switch 2");
                        break;
                    case 3:System.out.println("Instruccion Esperar");
                        /*Runnable miRunnableEsperar = new Runnable()
                        {
                        public void run()
                        {*/
                            while(hablando==true || moviendo==true){
                            try {sleep( 2500 );} catch( InterruptedException e ) {}
                                }
                            propietario.update(propietario.getGraphics());
                         /*}
                         };
                        Thread hilo4 = new Thread (miRunnableEsperar);
                        hilo4.start();(*/
                        break;
                case 4: System.exit(0);
                    break;
                case 5:
                    personaje=accion.get(1).toString().trim();
                    int posFinX2=Integer.parseInt(accion.get(2).toString());
                    int posFinY2=Integer.parseInt(accion.get(3).toString());
                    int posFinZ2=Integer.parseInt(accion.get(4).toString());
                    for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.setPosicion(posFinX2,posFinY2,posFinZ2);
                            }
                    }
                    break;
                case 6: personaje=accion.get(1).toString().trim();
                    int tintasel=Integer.parseInt(accion.get(2).toString());
                    for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.tinta=tintasel;
                            }
                    }
                    break;
                 case 7: personaje=accion.get(1).toString().trim();
                    for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                ele.nombre=accion.get(2).toString();
                            }
                    }
                    break;
                case 8:
                    sis.personaje=accion.get(1).toString().trim();
                    propietario.update(propietario.getGraphics());
                    //Hacer cambio de habitacion si es necesario
                    //Por Implementar
                    break;
                case 9: int ms=Integer.parseInt(accion.get(1).toString().trim());
                    try { sleep( ms );} catch( InterruptedException e ) {}
                    break;
                case 10:System.out.println("Instruccion CAMINAR");
                    personaje=accion.get(1).toString().trim();
                    final int posFinX3=Integer.parseInt(accion.get(2).toString());
                    final int posFinY3=Integer.parseInt(accion.get(3).toString());
                       Runnable miRunnableCaminar = new Runnable()
                        {
                        public void run()
                        {
                         while (moviendo==true){
                            try {
                                        sleep( 1000/sis.fps  );
                                    } catch( InterruptedException e ) {
                                }
                        }
                         moviendo=true;
                       for(int j=0;j<elementos.size();j++){
                            Elemento ele=(Elemento)elementos.get(j);
                            if(personaje.equals(ele.nombre.trim())){
                                int[] posi=new int[3];
                                posi=ele.getPosicion();
                                Image elementoImagen=ele.getImagen();
                                int posH=elementoImagen.getHeight(propietario);
                                int posW=elementoImagen.getWidth(propietario);
                                int OFFSET=1;

                                while(posi[0]!=posFinX3 || posi[1]!=(posFinY3-(posH-10))){
                                    //System.out.println(posi[0]+"+"+posi[1]+" Final "+posFinX+":"+posFinY);
                                    if(posFinX3>posi[0]){
                                        posi[0]=posi[0]+OFFSET;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    if(posFinX3<posi[0]){
                                        posi[0]=posi[0]-OFFSET;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    if((posFinY3-(posH-10))>posi[1]){
                                        posi[1]++;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    if((posFinY3-(posH-10))<posi[1]){
                                        posi[1]--;
                                        ele.setPosicion(posi[0],posi[1],0);
                                        propietario.update(propietario.getGraphics());
                                    }
                                    try {
                                        sleep( 10 );
                                    } catch( InterruptedException e ) {
                                }

                            }
                            moviendo=false;
                            }
                       }

                         }
                         };
                        Thread hilo5 = new Thread (miRunnableCaminar);
                        hilo5.start();

                        break;
                case 11://Cambiar habitacion actual
                    System.out.println("Instruccion SALTAR");
                    sis.habitacionInicial=accion.get(1).toString().trim();
                    propietario.update(propietario.getGraphics());
                    break;
                case 12:break;
                case 13:break;
                case 14:break;
                case 15:break;
                case 16:break;
                case 17: //Colocar personaje en nueva habitacion
                        for(int f=0;f<room.size();f++){
                              if(((Cuarto)room.get(f)).nombre.equals(sistema.habitacionInicial)){
                                habi=(Cuarto)room.get(f);
                                }
                        }
                        habi.elementos.add(sis.personajeelemento);
                        propietario.update(propietario.getGraphics());
                        break;
                case 18:sis.personajeelemento.setPosicion(Integer.parseInt(accion.get(2).toString()), Integer.parseInt(accion.get(3).toString()), Integer.parseInt(accion.get(4).toString()));
                    break;

                }
            }

        }
    /**
     * Ejecucion en hilo aparte.
     */
    @Override
    public void run(){

    }
}
